# Uses of Class
org.apache.lucene.codecs.KnnVectorsWriter

Packages that use KnnVectorsWriter
Package
Description
org.apache.lucene.codecs
Codecs API: API for customization of the encoding and structure of the index.
org.apache.lucene.codecs.hnsw
HNSW vector helper classes.
org.apache.lucene.codecs.lucene99
Lucene 9.9 file format.
org.apache.lucene.codecs.perfield
Postings format that can delegate to different formats per-field.

## Uses of KnnVectorsWriter in org.apache.lucene.codecs

Subclasses of KnnVectorsWriter in org.apache.lucene.codecs
Modifier and Type
Class
Description
`class`
`BufferingKnnVectorsWriter`
Buffers up pending vector value(s) per doc, then flushes when segment flushes.
Methods in org.apache.lucene.codecs that return KnnVectorsWriter
Modifier and Type
Method
Description
`abstract KnnVectorsWriter`
KnnVectorsFormat.`fieldsWriter(SegmentWriteState state)`
Returns a `KnnVectorsWriter` to write the vectors to the index.

## Uses of KnnVectorsWriter in org.apache.lucene.codecs.hnsw

Subclasses of KnnVectorsWriter in org.apache.lucene.codecs.hnsw
Modifier and Type
Class
Description
`class`
`FlatVectorsWriter`
Vectors' writer for a field that allows additional indexing logic to be implemented by the caller

## Uses of KnnVectorsWriter in org.apache.lucene.codecs.lucene99

Subclasses of KnnVectorsWriter in org.apache.lucene.codecs.lucene99
Modifier and Type
Class
Description
`final class`
`Lucene99FlatVectorsWriter`
Writes vector values to index segments.
`final class`
`Lucene99HnswVectorsWriter`
Writes vector values and knn graphs to index segments.
`final class`
`Lucene99ScalarQuantizedVectorsWriter`
Writes quantized vector values and metadata to index segments.
Methods in org.apache.lucene.codecs.lucene99 that return KnnVectorsWriter
Modifier and Type
Method
Description
`KnnVectorsWriter`
Lucene99HnswScalarQuantizedVectorsFormat.`fieldsWriter(SegmentWriteState state)`
`KnnVectorsWriter`
Lucene99HnswVectorsFormat.`fieldsWriter(SegmentWriteState state)`

## Uses of KnnVectorsWriter in org.apache.lucene.codecs.perfield

Methods in org.apache.lucene.codecs.perfield that return KnnVectorsWriter
Modifier and Type
Method
Description
`KnnVectorsWriter`
PerFieldKnnVectorsFormat.`fieldsWriter(SegmentWriteState state)`